package net.swengineer.codegraph.finders;

import com.intellij.psi.PsiNamedElement;

/**
 * Represents a Usage, relation between two elements
 *
 * @author Aviram Segal
 * @version 1.0
 */
public class Usage {
    public enum Type {
        //Class->Class
        EXTENDS, IMPLEMENTS,
        //Class->Class/Method/Field
        CONTAINS,
        //Method->Method
        OVERRIDES, CALLS,
        //Method->Field
        READS, ASSIGNS,
        //Field->Class
        TYPEOF
    }

    private PsiNamedElement source;
    private PsiNamedElement target;
    private Type type;

    public Usage(PsiNamedElement source, PsiNamedElement target, Type type) {
        this.source = source;
        this.target = target;
        this.type = type;
    }

    public PsiNamedElement getSource() {
        return source;
    }

    public PsiNamedElement getTarget() {
        return target;
    }

    public Type getType() {
        return type;
    }
}
