package net.swengineer.codegraph.graph.presentation;

import net.swengineer.codegraph.finders.Usage;
import net.swengineer.codegraph.graph.model.CodeGraphNode;

import java.util.HashMap;
import java.util.Map;

/**
 * Naming of node and edges types
 *
 * @author Aviram Segal
 * @version 1.0
 */
public class CodeGraphTypeNames {
    static Map<CodeGraphNode.Type, String> nodes;
    static Map<Usage.Type, String> edges;

    static {
        nodes = new HashMap<CodeGraphNode.Type, String>();
        edges = new HashMap<Usage.Type, String>();

        nodes.put(CodeGraphNode.Type.CLASS, "Class");
        nodes.put(CodeGraphNode.Type.INTERFACE, "Interface");
        nodes.put(CodeGraphNode.Type.METHOD, "Method");
        nodes.put(CodeGraphNode.Type.FIELD, "Field");

        edges.put(Usage.Type.EXTENDS, "Extends");
        edges.put(Usage.Type.IMPLEMENTS, "Implements");
        edges.put(Usage.Type.CONTAINS, "Contains");
        edges.put(Usage.Type.OVERRIDES, "Overrides");
        edges.put(Usage.Type.CALLS, "Calls");
        edges.put(Usage.Type.READS, "Reads");
        edges.put(Usage.Type.ASSIGNS, "Assigns");
        edges.put(Usage.Type.TYPEOF, "Type of");
    }

    public static String getTypeName(CodeGraphNode.Type type) {
        String name = nodes.get(type);
        if (name == null) {
            name = "";
        }
        return name;
    }

    public static String getTypeName(Usage.Type type) {
        String name = edges.get(type);
        if (name == null) {
            name = "";
        }
        return name;
    }
}
