package net.swengineer.codegraph.graph.presentation.popupmenu;

import com.intellij.openapi.graph.base.Node;
import com.intellij.pom.Navigatable;
import com.intellij.psi.PsiElement;
import net.swengineer.codegraph.graph.CodeGraph;
import net.swengineer.codegraph.graph.model.CodeGraphNode;

import javax.swing.*;
import java.awt.event.ActionEvent;

/**
 * Common menu actions for all node types
 *
 * @author Aviram Segal
 * @version 1.0
 */
public class CommonMenuActions {
    public static void addAllActions(CodeGraph codeGraph, JPopupMenu menu, Node node) {
        menu.add(getJumpToCodeAction(codeGraph, node));
    }

    public static Action getJumpToCodeAction(final CodeGraph codeGraph, final Node v) {
        return new AbstractAction("Jump to code") {
            public void actionPerformed(ActionEvent e) {
                CodeGraphNode node = codeGraph.getCodeGraphNode(v);
                PsiElement element = node.getElement();
                PsiElement navigationElement = element.getNavigationElement();
                if (navigationElement != null && navigationElement instanceof Navigatable && ((Navigatable) navigationElement).canNavigate()) {
                    ((Navigatable) navigationElement).navigate(true);
                }
            }
        };
    }
}
