package net.swengineer.codegraph.plugin.actions;

import com.intellij.openapi.actionSystem.AnAction;
import com.intellij.openapi.actionSystem.AnActionEvent;
import com.intellij.openapi.actionSystem.DataKeys;
import com.intellij.psi.PsiElement;
import com.intellij.psi.PsiNamedElement;
import net.swengineer.codegraph.graph.CodeGraph;
import net.swengineer.codegraph.graph.model.CodeGraphNode;
import net.swengineer.codegraph.plugin.project.CodeGraphToolWindow;

/**
 * An action for adding a single element to the Code Graph
 * the element to be added is the element of the event
 *
 * @author Aviram Segal
 * @version 1.0
 */
public class AddElementAction extends AnAction {
    public void actionPerformed(AnActionEvent e) {
        PsiElement element = e.getData(DataKeys.PSI_ELEMENT);
        if (element instanceof PsiNamedElement) {
            PsiNamedElement namedElement = (PsiNamedElement) element;
            CodeGraph codeGraph = element.getProject().getUserData(CodeGraphToolWindow.CODE_GRAPH_KEY);
            codeGraph.clear();
            codeGraph.getDataModel().addNode(new CodeGraphNode(namedElement));
            codeGraph.updateGraph();
            codeGraph.fitContent();
        }
    }
}
